#import "MonadEmapleBefore.h"

#import "Api.h"

@implementation MonadEmapleBefore

-(JFFAsyncOperation)addNewPostToCompanyWithId:( NSString* )company_id
                                 newPostTitle:( NSString* )new_post_title_
                                  newPostText:( NSString* )new_post_text_
{
    JFFAsyncOperation publish_text_item_ = [ self.api  publishTextItemInCompanyWithId: company_id
                                                                        textItemTitle: new_post_title_
                                                                         textItemText: new_post_text_ ];

    JFFResultContext* publish_text_item_result_ = [ JFFResultContext new ];
    publish_text_item_ = asyncOperationWithFinishCallbackBlock( publish_text_item_
                                                               , ^void( id result_, NSError* error_ )
    {
        publish_text_item_result_.result = result_;
        publish_text_item_result_.error = error_;
    } );

    JFFAsyncOperation package_draft_ = [ self.api makeDraftPackageInCompanyWithId: company_id
                                                                     packageTitle: new_post_title_ ];
    JFFResultContext* package_draft_result_ = [ JFFResultContext new ];
    package_draft_ = asyncOperationWithFinishCallbackBlock( package_draft_
                                                           , ^void( id result_, NSError* error_ )
    {
        package_draft_result_.result = result_;
        package_draft_result_.error = error_;
    } );

    JFFAsyncOperation add_text_item_to_package_ = ^JFFCancelAsyncOperation( JFFAsyncOperationProgressHandler progress_callback_
                                                                           , JFFCancelAsyncOperationHandler cancel_callback_
                                                                           , JFFDidFinishAsyncOperationHandler done_callback_ )
    {
        JFFAsyncOperation add_text_item_to_package_loader_ = [ self.api addRelatedItemToPackageWithId: package_draft_result_.result
                                                                                        relatedItemId: publish_text_item_result_.result
                                                                                     relatedItemTitle: new_post_title_ ];

        return add_text_item_to_package_loader_( progress_callback_, cancel_callback_, done_callback_ );
    };

    JFFAsyncOperation publish_package_ = ^JFFCancelAsyncOperation( JFFAsyncOperationProgressHandler progress_callback_
                                                                  , JFFCancelAsyncOperationHandler cancel_callback_
                                                                  , JFFDidFinishAsyncOperationHandler done_callback_ )
    {
        JFFAsyncOperation publish_package_loader_ = [ self.api publishPackageWithId: package_draft_result_.result
                                                                       packageTitle: new_post_title_ ];

        return publish_package_loader_( progress_callback_, cancel_callback_, done_callback_ );
    };

    return sequenceOfAsyncOperations( publish_text_item_
                                     , package_draft_
                                     , add_text_item_to_package_
                                     , publish_package_, nil );
}

@end
