//#ifndef __COCOA_HELPERS_H__
//#define __COCOA_HELPERS_H__

#import <Foundation/Foundation.h>
#define PROPERTY_TO_STRING( PROPERTY ) NSStringFromSelector( @selector( PROPERTY ) )


#define ENCODE_OBJECT_PROPERTY( CODER, PROPERTY ) [ CODER encodeObject: self.PROPERTY forKey: PROPERTY_TO_STRING( PROPERTY ) ];
#define DECODE_OBJECT_PROPERTY( CODER, PROPERTY ) self.PROPERTY = [ CODER decodeObjectForKey: PROPERTY_TO_STRING( PROPERTY ) ];


#define ENCODE_INTEGER_PROPERTY( CODER, PROPERTY ) [ CODER encodeInteger: self.PROPERTY forKey: PROPERTY_TO_STRING( PROPERTY ) ];
#define DECODE_INTEGER_PROPERTY( CODER, PROPERTY ) self.PROPERTY = [ CODER decodeIntegerForKey: PROPERTY_TO_STRING( PROPERTY ) ];

#define ENCODE_BOOL_PROPERTY( CODER, PROPERTY ) [ CODER encodeBool: self.PROPERTY forKey: PROPERTY_TO_STRING( PROPERTY ) ];
#define DECODE_BOOL_PROPERTY( CODER, PROPERTY ) self.PROPERTY = [ CODER decodeBoolForKey: PROPERTY_TO_STRING( PROPERTY ) ];


//#endif //__COCOA_HELPERS_H__

